#{extends 'cms/menu-tab-base.html' /}
<div class="card-header">
    Template Profile K/L/P/D
</div>
<div class="card-body">
    #{common.alert /}
    <div class="alert alert-danger alert-modal hidden"></div>
    <form action="" method="post" id="inputProfileKl" class="inputProfileKl">
        <input type="hidden" name="model.action" id="statusAction" value="${model?.action}">
        <input type="hidden" name="model.id" value="${model?.id}" >
        #{include 'cms/parts/kldi-selection.html' /}
        <div class="form-group has-feedback">
            <div class="row">
                <label for="title" class="col-6 control-label">Judul Profile K/L/P/D</label>
                <input type="text" name="model.title" id="title" placeholder="Silahkan masukkan judul profile K/L/P/D" value="${model?.title}" class="col-12 form-control">
                <span class="form-control-feedback"></span>
                <span class="help-block">#{error 'model.title' /}</span>
            </div>
        </div>
        #{cms.content-banner-upload model:model /}
        <div class="form-group">
            <div class="row">
                <label for="vision" class="col-2 control-label">Visi</label>
                <div class="col-12 #{errorClass 'model.vision'/} summernote-wrapper">
                    <textarea class="form-control vision" name="model.vision" id="vision" rows="10" cols="80">${model?.vision}</textarea>
                </div>
                <span class="help-block vision-error">#{error 'model.vision' /}</span>
            </div>
        </div>
        <div class="form-group">
            <div class="row">
                <label for="mission" class="col control-label">Misi</label>
                <div class="col-sm-12 #{errorClass 'model.mission'/} summernote-wrapper">
                    <textarea class="form-control mission" name="model.mission" id="mission" rows="10" cols="80">${model?.mission}</textarea>
                </div>
                <span class="help-block mission-error">#{error 'model.mission' /}</span>
            </div>
        </div>

        #{cms.multiple-file-upload selector:'Mou', title:'Mou', files:model.uploadedMous /}
        #{cms.multiple-file-upload selector:'Regulasi', title:'Regulasi/SOP/Lainnya', files:model.uploadedRegulations /}

        <div class="form-group">
            <div class="row">
                <label for="content" class="col control-label">Konten Bebas</label>
                <div class="col-sm-12 #{errorClass 'model.content'/} summernote-wrapper">
                    <textarea class="form-control content" name="model.content" id="content" rows="10" cols="80">${model?.content}</textarea>
                </div>
                <span class="help-block content">#{error 'content' /}</span>
            </div>
        </div>
        #{cms.multiple-file-upload selector:'Extra', title:'File Bebas', files:model.uploadedExtras /}
        #{include 'cms/parts/publishing-status.html' /}
        <div class="form-group">
            <div class="row"style="justify-content:center;">
                <a href='' class="btn btn-success" id="save_profile_kl"><i class="fa fa-save"></i> Lanjut</a>
                &nbsp;&nbsp;
                <a href='@{index()}' class="btn btn-warning"><i class="fa fa-arrow-circle-left"></i> Kembali</a>
            </div>
        </div>
    </form>
</div>

#{set 'tabContentScripts' }
<script>
#{if isUser}
$(".kldi_id").prop("disabled", true);
#{/if}

$(document).ready(function() {
    $('#content').summernote({
        height: ($(window).height() - 450),
        placeholder: 'Silahkan masukkan konten bebas',
        toolbar: [
            ['style', ['style']],
            ['font', ['bold', 'italic', 'underline', 'clear']],
            ['fontname', ['fontname']],
            ['color', ['color']],
            ['para', ['ul', 'ol', 'paragraph']],
            ['table', ['table']],
            ['insert', ['link', 'picture', 'video']],
            ['view', ['fullscreen', 'codeview', 'help']],
        ],
        callbacks: {
            onImageUpload: function(image, editor, welEditable) {
                $('progress').attr('value','0.0');
                uploadImage(image[0], editor, welEditable);
            },
            onMediaDelete: function(image) {
                    deleteImage(image[0].src);
            },
            onKeyup: function(e) {
                    if(e.currentTarget.innerText.length > 0) {
                    $(this).valid();
                    }
            },
        }
    });

    function initSummernote(selector, placeholder) {
        $(selector).summernote({
            height: ($(window).height() - 450),
            placeholder: placeholder,
            toolbar: [
                ['style', ['style']],
                ['font', ['bold', 'italic', 'underline', 'clear']],
                ['fontname', ['fontname']],
                ['color', ['color']],
                ['para', ['ul', 'ol', 'paragraph']],
                ['view', ['fullscreen', 'codeview', 'help']],
            ],
            callbacks: {
                onKeyup: function(e) {
                    if(e.currentTarget.innerText.length > 0) {
                        $(this).valid();
                    }
                },
            }
            })
    }

    initSummernote('#mission', 'Silahkan masukkan misi profile K/L/P/D')
    initSummernote('#vision', 'Silahkan masukkan visi profile K/L/P/D')

});


</script>
<script>
$(document).ready(function() {

    var status= $('#statusAction').val();
    var extmou;
    var uploadmou;

    $('#attachMoreMou').click(function(e) {
        e.preventDefault()
        generateAttachMoreElement('uploadMou', 'Mou', "#moreFileMou")
    })
    registerFileChange(".uploadMou", "#moreFileMou")
    registerDeleteAttachment('.del_file_uploadMou', 'mou')

    $('#attachMoreRegulasi').click(function(e) {
        e.preventDefault()
        generateAttachMoreElement("uploadRegulasi", "Regulasi/SOP/Lainnya", "#moreFileRegulasi")
    })
    registerFileChange('.uploadRegulasi', "#moreFileRegulasi")
    registerDeleteAttachment('.del_file_uploadRegulasi', 'Regulasi/SOP/Lainnya')

    $('#attachMoreExtra').click(function(e) {
        e.preventDefault();
        generateAttachMoreElement("uploadExtra", "File Bebas", "#moreFileExtra")
    })
    registerFileChange('.uploadExtra', "#moreFileExtra")
    registerDeleteAttachment('.del_file_uploadExtra', 'File bebas')


    function generateFormData() {
        var data = new FormData($('#inputProfileKl')[0]);
        data.set("model.uploadfile", uploadfile);
        appendFilesToFormBy(data, '.uploadMou')
        appendFilesToFormBy(data, '.uploadRegulasi')
        appendFilesToFormBy(data, '.uploadExtra')
        data.set("model.deletedFiles", deletedFiles)
        return data
    }

    function sendRequest() {
        var data = generateFormData()
        $('.alert-modal').addClass('hidden');
        $.ajax({
            async:true,
            type: "POST",
            cache: false,
            contentType: false,
            processData: false,
            url: "#{url route.cms_contentapicontroller_storeprofilekl /}",
            data: data,
            beforeSend: function(){blockPageUI();},
            success: function(result){
                if (result.status){
                    $('.alert-modal').removeClass('hidden')
                        .removeClass('alert-danger')
                        .addClass('alert-success')
                        .html(result.message);
                    setDataAndChangeTab(result)
                } else {
                    $('.alert-modal')
                            .addClass('alert-danger')
                            .removeClass('alert-success')
                            .removeClass('hidden').html(result.message);
                }
            },
            complete: function(){unblockPageUI();},
            error: function(){
                unblockPageUI();
                $('.alert-modal')
                        .addClass('alert-danger')
                        .removeClass('alert-success')
                        .removeClass('hidden').html('&{translation.general_error}');
            }
        });
    }

    function generateValidationRules(options) {
        $('#inputProfileKl').validate({
            rules: options.rules,
            ignore: '.note-editor *',
            ignore: [],
            onkeyup: validate_function,
            onfocusout: validate_function,
            messages: options.messages,
            errorElement: 'span',
            errorClass: 'help-block',
            focusInvalid: false,
            errorPlacement: function(error, element) {
            var elem = $(element);
            if (elem.hasClass("kldi_id")) {
                element = $("span.select2.select2-container");
                element2 = $("span.select2-selection.select2-selection--single");
                error.insertAfter(element);
                element2.addClass('has-error');
            }
            else { error.insertAfter(element); }
            },
            highlight: function (element) {
                $(element).closest('.form-group').addClass('has-error');
            },
            success: function (label, element) {
                label.closest('.form-group').removeClass('has-error');
                label.remove();
                var elem = $(element);
                if (elem.hasClass("select2-hidden-accessible")) {
                element2 = $("#select2-" + elem.attr("id") + "-container").parent();
                element2.removeClass('has-error');
            }
            }
        })
    }

    let creationRules = {
            rules: {
                "model.title": "required",
                #{if !isUser}
                "model.kldi_id": "required",
                #{/if}
                "model.uploadfile": "required",
                "model.uploadmou[]": "required",
                "model.uploadregulasi[]": "required",
                "model.vision": "required",
                "model.mission": "required",
                "model.content": "required",
                "model.uploadfreecontent[]": "required",
                "model.publish": "required"
            },
            messages: {
                "model.title": "Judul profile K/L/P/D belum diisi",
                #{if !isUser}
                "model.kldi_id": "Daftar K/L/P/D belum dipilih",
                #{/if}
                "model.uploadfile": "File Banner belum dipilih",
                "model.uploadmou[]": "File MOU belum dipilih",
                "model.uploadregulasi[]": "File Regulasi belum dipilih",
                "model.vision": "Visi belum diisi",
                "model.mission": "Misi belum diisi",
                "model.content": "Konten bebas belum diisi",
                "model.uploadfreecontent[]": "File konten bebas belum dipilih",
                "model.publish": "Status publish belum dipilih"
            }
        }

        let updateRules = {
            rules: {
                    "model.title": "required",
                    #{if !isUser}
                    "model.kldi_id": "required",
                    #{/if}
                    "model.vision": "required",
                    "model.mission": "required",
                    "model.content": "required",
                    "model.publish": "required"
                },
            messages: {
                    "model.title": "Judul profile K/L/P/D belum diisi",
                    #{if !isUser}
                    "model.kldi_id": "Daftar K/L/P/D belum dipilih",
                    #{/if}
                    "model.vision": "Visi belum diisi",
                    "model.mission": "Misi belum diisi",
                    "model.content": "Konten bebas belum diisi",
                    "model.publish": "Status publish belum dipilih"
                }
        }


        $('#save_profile_kl').click(function(e) {
            e.preventDefault();
            generateValidationRules((status == 'create') ? creationRules : updateRules)
            if (!$('form.inputProfileKl').valid()) {
                return
            }
            sendRequest()
        })
    })
</script>
#{/set}